    
    #include <fstream>
    #include <iostream>
    
    #include <memory>
    
    #include "zeldagame.h"
    #include "containers.h"
    
    #include "compresch_lttp.h"
    
// ===============================================================
    
    ZeldaGame::ZeldaGame()
    {
        /// todo: who knows for now?
    }
    
// ===============================================================
    
    ZeldaGame::~ZeldaGame()
    {
        /// todo: identify any dynamically allocated members and
        /// delete them
    }
    
// ===============================================================
    
    uint8_t test_blah[] =
    {
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 5, 3,
        0, 0, 0, 1, 2, 0, 0, 0, 5, 3,
        0, 0, 0, 2, 1, 0, 0, 0, 5, 3,
        0, 0, 0, 0, 0, 0, 0, 0, 5, 3,
        0, 0, 0, 0, 0, 0, 0, 0, 5, 3,
        0, 0, 1, 2, 0, 0, 0, 0, 5, 3,
        0, 0, 2, 1, 0, 0, 0, 0, 5, 3,
        0, 0, 0, 0, 0, 0, 1, 2, 5, 3,
        0, 0, 0, 0, 0, 0, 2, 1, 5, 3
    };
    
    uint8_t test_augmented[] =
    {
        0, 0, 0, 0, 0, 0, 0, 0, 5, 3, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 5, 3, 5, 3,
        0, 0, 0, 1, 2, 0, 0, 0, 5, 3, 5, 3,
        0, 0, 0, 2, 1, 0, 0, 0, 5, 3, 5, 3,
        0, 0, 0, 0, 0, 0, 0, 0, 5, 3, 5, 3,
        0, 0, 0, 0, 0, 0, 0, 0, 5, 3, 5, 3,
        0, 0, 1, 2, 0, 0, 0, 0, 5, 3, 5, 0,
        0, 0, 2, 1, 0, 0, 0, 0, 5, 3, 5, 0,
        0, 0, 0, 0, 0, 0, 1, 2, 5, 3, 0, 0,
        0, 0, 0, 0, 0, 0, 2, 1, 5, 3, 0, 0
    };
    
    uint8_t test2[] =
    {
        0, 1, 2, 0, 1, 2, 0, 1, 2, 0,
        0, 1, 2, 0, 1, 2, 0, 1, 2, 0,
        1, 2, 0, 1, 2, 0, 1, 2, 0, 1,
        1, 2, 0, 1, 2, 0, 1, 2, 0, 1,
        2, 0, 1, 2, 0, 1, 2, 0, 1, 2,
        2, 0, 1, 2, 0, 1, 2, 0, 1, 2,
        0, 1, 2, 0, 1, 2, 0, 1, 2, 0,
        0, 1, 2, 0, 1, 2, 0, 1, 2, 0,
        1, 2, 0, 1, 2, 0, 1, 2, 0, 1,
        1, 2, 0, 1, 2, 0, 1, 2, 0, 1
    };
    
    const uint8_t test3[] =
    {
        3, 4, 5, 1, 2, 7, 0, 6, 6, 6,
        3, 4, 5, 0, 1, 2, 7, 6, 6, 6,
        3, 4, 5, 0, 0, 1, 2, 7, 6, 6,
        3, 4, 5, 0, 8, 9, 1, 2, 7, 6,
        3, 4, 5, 8, 9, 4, 4, 1, 2, 7,
        7, 0, 8, 9, 3, 3, 3, 3, 1, 2,
        2, 8, 9, 4, 4, 4, 4, 4, 4, 1,
        1, 2, 5, 5, 5, 5, 5, 5, 5, 5,
        6, 1, 2, 5, 5, 5, 5, 5, 5, 5,
        6, 6, 1, 2, 5, 5, 5, 5, 5, 5
    };
    
// ===============================================================

    void ZeldaGame::Test2DCompression()
    {
        using std::find;
        using std::min;
        
        using std::cout;
        using std::cin;
        using std::endl;
        
        using std::exception;
        
        using Containers::Matrix;
        
        int i = 0, j = 0;
        
        Matrix<uint8_t> m(10, 10, test3);
        Matrix<uint8_t> n(1, 1);
        
        Matrix<uint8_t>::MatrixList patterns;
        
        Matrix<uint8_t>::MatrixList trash;
        
        Matrix<uint8_t>::MatrixPairList pairs;
        
        // ---------------------------------------------
        
        cout << "Begin test" << endl;
        
        // find all tiles (1x1s) that are repeated and make patterns from them
        for(i = 0; i < m.m_rows; ++i)
        {
            for(j = 0; j < m.m_columns; ++j)
            {
                n(0, 0) = m(i, j);
                
                if( find(patterns.begin(), patterns.end(), n) == patterns.end() )
                {
                    if( m.Count(n) > 1 )
                    {
                        patterns.push_back(n);
                    }
                }
            }
        }
        
        while(true)
        {
            Matrix<uint8_t>::MatrixList patterns2;
            
            // -------------------------------
            
            for
            (
                Matrix<uint8_t>::MatrixList::iterator a = patterns.begin();
                a != patterns.end();
                ++a
            )
            {
                for
                (
                    Matrix<uint8_t>::MatrixList::iterator b = patterns.begin();
                    b != patterns.end();
                    ++b
                )
                {
                    Matrix<uint8_t>::MatrixPair p( (*a), (*b) );
                    
                    // -----------------------------------------------------
                    
                    if( find(pairs.begin(), pairs.end(), p) != pairs.end() )
                    {
                        continue;
                    }
                    
                    pairs.push_back(p);
                    
                    if(p.first == p.second)
                    {
                        continue;
                    }
                    
                    // first pass is concatenate right, second is concatenate down
                    for(i = 0; i < 2; ++i)
                    {
                        try
                        {
                            int coverage = 0;
                            int count    = 0;
                            
                            Matrix<uint8_t> combo =  (i == 0)
                                                    ? Matrix<uint8_t>::ConcatRight(p.first, p.second)
                                                    : Matrix<uint8_t>::ConcatDown(p.first, p.second);
                            
                            // ----------------------------------------------------------------
                            
                            if(combo.IsCyclic())
                            {
                                continue;
                            }
                            
                            if(i == 0)
                            {
                                int rows       = p.first.m_rows;
                                int minColumns = min(p.first.m_columns,
                                                     p.second.m_columns);
                                
                                // -------------------------------------------
                                
                                if( p.first(0, p.first.m_columns - minColumns, rows, minColumns) == p.second )
                                {
                                    continue;
                                }
                                else if( p.first == p.second(0, 0, rows, minColumns) )
                                {
                                    continue;
                                }
                            }
                            else
                            {
                                int minRows = min(p.first.m_rows,
                                                  p.second.m_rows);
                                
                                int columns = p.first.m_columns;
                                
                                // -------------------------------------------
                                
                                if( p.first(p.first.m_rows - minRows, 0, minRows, columns) == p.second)
                                {
                                    continue;
                                }
                                else if( p.first == p.second(0,
                                                             0,
                                                             minRows,
                                                             columns) )
                                {
                                    continue;
                                }
                            }
                            
                            count = m.Count(combo);
                            
                            if(count < 2)
                            {
                                continue;
                            }
                            else
                            {
                                coverage = m.Coverage(combo);
                            }
                            
                            if( (m.Coverage(combo) / m.Count(combo) ) >= 2)
                            {
                                patterns2.push_back(combo);
                            }
                            else
                            {
                                trash.push_back(combo);
                            }
                        }
                        catch( exception &e)
                        {
                            const char* durp = e.what();
                            /// cout << endl << e.what() << endl;
                        }
                    }
                }
            }
            
            if(patterns2.size() == 0)
            {
                break;
            }
            else
            {
                int additions = 0;
                
                Matrix<uint8_t>::MatrixList::iterator a;
                
                // ----------------------------
                
                for(a = patterns2.begin(); a != patterns2.end(); a++)
                {
                    if( find( patterns.begin(), patterns.end(), (*a)) == patterns.end() )
                    {
                        additions += 1;
                        patterns.push_back( (*a) );
                        
                        /// cout << "\nAdding...\n" << (*a).ToString() << "\n";
                    }
                }
                
                if(additions == 0)
                {
                    break;
                }
            }
        }
        
        cout << "End Test" << endl;
        
        int dummy = 0;
        
        cin >> dummy;
        
        cout << m.ToString() << endl << endl;
        
        for
        (
            Matrix<uint8_t>::MatrixList::iterator a = patterns.begin();
            a != patterns.end();
            ++a)
        {
            cout << endl << (*a).ToString() << endl;
        }
    }
    
// ===============================================================

    #if 0
    void ZeldaGame::TestCompresch()
    {
        int compSize    = 0;
        int decompSize  = 0;
        int decompSize2 = 0;
        int matchLen    = 0;
        
        std::ifstream f("C:\\RH\\Rom_Hacking\\Assemblers\\Xkas_v06\\readonly_supermetroid.smc",
                        std::ios::binary | std::ios::in);
        
        std::ofstream f2("C:\\RH\\sm_test_gfx.bin", std::ios::binary | std::ios::out);
        
        u8 *decompBuf  = new u8[0x10000];
        u8 *decompBuf2 = new u8[0x10000];
        u8 *compBuf    = new u8[0x10000];
        
        char *r_metroid3 = new char[0x400000];
        
        Compresch_LTTP t;
        
        // ---------------------------------------
        
        f.read(r_metroid3, 0x400000);
        f.close();
        
        decompSize = t.Decompress( (const u8*) (r_metroid3 + 0x20B6F6),
                                   0x400000,
                                   decompBuf);
        
        f2.write( (const char*) decompBuf, decompSize);
        f2.close();
        
        for(int i = 0; i < compSize; ++i)
        {
            if( (i % 16) == 0)
            {
                printf("\n");
            }
            
            printf("%02x, ", decompBuf[i]);
        }
        
        compSize = Compresch_LTTP::Compress((const u8*) decompBuf, decompSize, compBuf);
        
        decompSize2 = t.Decompress(compBuf, compSize, decompBuf2);
        
        for(int i = 0; i < decompSize; ++i)
        {
            if(decompBuf[i] == decompBuf2[i])
            {
                matchLen += 1;
            }
            else
            {
                break;
            }
        }
        
        f2.open("C:\\RH\\sm_test_gfx_after.bin", std::ios::binary | std::ios::out);
        
        f2.write( (const char*) decompBuf2, decompSize2);
        f2.close();
        
        delete[] decompBuf2;
        delete[] decompBuf;
        delete[] compBuf;
        delete[] r_metroid3;
        
        
        return;
    }
    #endif

// ===============================================================
