#pragma once

    #include <iostream>
    #include <fstream>

    #include "expandinfo.h"
    #include "loaders.h"
    #include "zeldagame.h"
    
    #include "ThemesDialog.h"

namespace ZTestGui {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Drawing::Imaging;

	/// <summary>
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~Form1()
		{
			if(components)
			{
				delete components;
			}
		}
		
		ExpandInfo *ei;
		ZeldaGame *zg;
    private: System::Windows::Forms::PictureBox^  image;
    private: System::Windows::Forms::MenuStrip^  menuStrip1;
    private: System::Windows::Forms::ToolStripMenuItem^  fileToolStripMenuItem;
    private: System::Windows::Forms::ToolStripMenuItem^  helpToolStripMenuItem;
    private: System::Windows::Forms::ToolStripMenuItem^  showThemesMenuItem;
    private: System::Windows::Forms::Timer^  frameTimer;
    private: System::Windows::Forms::ToolStrip^  toolStrip1;
    private: System::Windows::Forms::ToolStripButton^  toolStripButton1;
    private: System::Windows::Forms::ToolStripButton^  toolStripButton2;
    private: System::Windows::Forms::ToolStripButton^  toolStripButton3;
    private: System::Windows::Forms::ToolStripButton^  toolStripButton4;
    private: System::Windows::Forms::ToolStripButton^  toolStripButton5;
    private: System::Windows::Forms::ToolStripButton^  toolStripButton6;
    private: System::Windows::Forms::ToolStripButton^  toolStripButton7;
    private: System::Windows::Forms::ToolStripButton^  toolStripButton8;
    private: System::Windows::Forms::ToolStripButton^  toolStripButton9;
    private: System::Windows::Forms::ToolStripButton^  toolStripButton10;
    private: System::ComponentModel::IContainer^  components;
    protected: 


    protected: 

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
            this->components = (gcnew System::ComponentModel::Container());
            System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Form1::typeid));
            this->image = (gcnew System::Windows::Forms::PictureBox());
            this->menuStrip1 = (gcnew System::Windows::Forms::MenuStrip());
            this->fileToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
            this->showThemesMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
            this->helpToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
            this->frameTimer = (gcnew System::Windows::Forms::Timer(this->components));
            this->toolStrip1 = (gcnew System::Windows::Forms::ToolStrip());
            this->toolStripButton1 = (gcnew System::Windows::Forms::ToolStripButton());
            this->toolStripButton2 = (gcnew System::Windows::Forms::ToolStripButton());
            this->toolStripButton3 = (gcnew System::Windows::Forms::ToolStripButton());
            this->toolStripButton4 = (gcnew System::Windows::Forms::ToolStripButton());
            this->toolStripButton5 = (gcnew System::Windows::Forms::ToolStripButton());
            this->toolStripButton6 = (gcnew System::Windows::Forms::ToolStripButton());
            this->toolStripButton7 = (gcnew System::Windows::Forms::ToolStripButton());
            this->toolStripButton8 = (gcnew System::Windows::Forms::ToolStripButton());
            this->toolStripButton9 = (gcnew System::Windows::Forms::ToolStripButton());
            this->toolStripButton10 = (gcnew System::Windows::Forms::ToolStripButton());
            (cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->image))->BeginInit();
            this->menuStrip1->SuspendLayout();
            this->toolStrip1->SuspendLayout();
            this->SuspendLayout();
            // 
            // image
            // 
            this->image->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
                | System::Windows::Forms::AnchorStyles::Left) 
                | System::Windows::Forms::AnchorStyles::Right));
            this->image->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
            this->image->Location = System::Drawing::Point(12, 52);
            this->image->MaximumSize = System::Drawing::Size(1024, 1024);
            this->image->MinimumSize = System::Drawing::Size(512, 512);
            this->image->Name = L"image";
            this->image->Size = System::Drawing::Size(512, 512);
            this->image->TabIndex = 0;
            this->image->TabStop = false;
            // 
            // menuStrip1
            // 
            this->menuStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->fileToolStripMenuItem, 
                this->helpToolStripMenuItem});
            this->menuStrip1->Location = System::Drawing::Point(0, 0);
            this->menuStrip1->Name = L"menuStrip1";
            this->menuStrip1->Size = System::Drawing::Size(486, 24);
            this->menuStrip1->TabIndex = 1;
            this->menuStrip1->Text = L"menuStrip1";
            // 
            // fileToolStripMenuItem
            // 
            this->fileToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) {this->showThemesMenuItem});
            this->fileToolStripMenuItem->Name = L"fileToolStripMenuItem";
            this->fileToolStripMenuItem->Size = System::Drawing::Size(35, 20);
            this->fileToolStripMenuItem->Text = L"File";
            // 
            // showThemesMenuItem
            // 
            this->showThemesMenuItem->Name = L"showThemesMenuItem";
            this->showThemesMenuItem->Size = System::Drawing::Size(152, 22);
            this->showThemesMenuItem->Text = L"Show Themes";
            this->showThemesMenuItem->Click += gcnew System::EventHandler(this, &Form1::ShowThemeDialog);
            // 
            // helpToolStripMenuItem
            // 
            this->helpToolStripMenuItem->Name = L"helpToolStripMenuItem";
            this->helpToolStripMenuItem->Size = System::Drawing::Size(40, 20);
            this->helpToolStripMenuItem->Text = L"Help";
            // 
            // frameTimer
            // 
            this->frameTimer->Interval = 150;
            this->frameTimer->Tick += gcnew System::EventHandler(this, &Form1::frameTimer_Tick);
            // 
            // toolStrip1
            // 
            this->toolStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(10) {this->toolStripButton1, 
                this->toolStripButton2, this->toolStripButton3, this->toolStripButton4, this->toolStripButton5, this->toolStripButton6, this->toolStripButton7, 
                this->toolStripButton8, this->toolStripButton9, this->toolStripButton10});
            this->toolStrip1->Location = System::Drawing::Point(0, 24);
            this->toolStrip1->Name = L"toolStrip1";
            this->toolStrip1->Size = System::Drawing::Size(486, 25);
            this->toolStrip1->TabIndex = 2;
            this->toolStrip1->Text = L"toolStrip1";
            // 
            // toolStripButton1
            // 
            this->toolStripButton1->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
            this->toolStripButton1->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolStripButton1.Image")));
            this->toolStripButton1->ImageTransparentColor = System::Drawing::Color::Magenta;
            this->toolStripButton1->Name = L"toolStripButton1";
            this->toolStripButton1->Size = System::Drawing::Size(23, 22);
            this->toolStripButton1->Text = L"toolStripButton1";
            // 
            // toolStripButton2
            // 
            this->toolStripButton2->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
            this->toolStripButton2->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolStripButton2.Image")));
            this->toolStripButton2->ImageTransparentColor = System::Drawing::Color::Magenta;
            this->toolStripButton2->Name = L"toolStripButton2";
            this->toolStripButton2->Size = System::Drawing::Size(23, 22);
            this->toolStripButton2->Text = L"toolStripButton2";
            // 
            // toolStripButton3
            // 
            this->toolStripButton3->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
            this->toolStripButton3->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolStripButton3.Image")));
            this->toolStripButton3->ImageTransparentColor = System::Drawing::Color::Magenta;
            this->toolStripButton3->Name = L"toolStripButton3";
            this->toolStripButton3->Size = System::Drawing::Size(23, 22);
            this->toolStripButton3->Text = L"toolStripButton3";
            // 
            // toolStripButton4
            // 
            this->toolStripButton4->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
            this->toolStripButton4->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolStripButton4.Image")));
            this->toolStripButton4->ImageTransparentColor = System::Drawing::Color::Magenta;
            this->toolStripButton4->Name = L"toolStripButton4";
            this->toolStripButton4->Size = System::Drawing::Size(23, 22);
            this->toolStripButton4->Text = L"toolStripButton4";
            // 
            // toolStripButton5
            // 
            this->toolStripButton5->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
            this->toolStripButton5->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolStripButton5.Image")));
            this->toolStripButton5->ImageTransparentColor = System::Drawing::Color::Magenta;
            this->toolStripButton5->Name = L"toolStripButton5";
            this->toolStripButton5->Size = System::Drawing::Size(23, 22);
            this->toolStripButton5->Text = L"toolStripButton5";
            // 
            // toolStripButton6
            // 
            this->toolStripButton6->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
            this->toolStripButton6->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolStripButton6.Image")));
            this->toolStripButton6->ImageTransparentColor = System::Drawing::Color::Magenta;
            this->toolStripButton6->Name = L"toolStripButton6";
            this->toolStripButton6->Size = System::Drawing::Size(23, 22);
            this->toolStripButton6->Text = L"toolStripButton6";
            // 
            // toolStripButton7
            // 
            this->toolStripButton7->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
            this->toolStripButton7->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolStripButton7.Image")));
            this->toolStripButton7->ImageTransparentColor = System::Drawing::Color::Magenta;
            this->toolStripButton7->Name = L"toolStripButton7";
            this->toolStripButton7->Size = System::Drawing::Size(23, 22);
            this->toolStripButton7->Text = L"toolStripButton7";
            // 
            // toolStripButton8
            // 
            this->toolStripButton8->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
            this->toolStripButton8->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolStripButton8.Image")));
            this->toolStripButton8->ImageTransparentColor = System::Drawing::Color::Magenta;
            this->toolStripButton8->Name = L"toolStripButton8";
            this->toolStripButton8->Size = System::Drawing::Size(23, 22);
            this->toolStripButton8->Text = L"toolStripButton8";
            // 
            // toolStripButton9
            // 
            this->toolStripButton9->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
            this->toolStripButton9->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolStripButton9.Image")));
            this->toolStripButton9->ImageTransparentColor = System::Drawing::Color::Magenta;
            this->toolStripButton9->Name = L"toolStripButton9";
            this->toolStripButton9->Size = System::Drawing::Size(23, 22);
            this->toolStripButton9->Text = L"toolStripButton9";
            // 
            // toolStripButton10
            // 
            this->toolStripButton10->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
            this->toolStripButton10->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolStripButton10.Image")));
            this->toolStripButton10->ImageTransparentColor = System::Drawing::Color::Magenta;
            this->toolStripButton10->Name = L"toolStripButton10";
            this->toolStripButton10->Size = System::Drawing::Size(23, 22);
            this->toolStripButton10->Text = L"toolStripButton10";
            // 
            // Form1
            // 
            this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
            this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
            this->AutoScroll = true;
            this->AutoScrollMargin = System::Drawing::Size(16, 16);
            this->AutoScrollMinSize = System::Drawing::Size(100, 100);
            this->ClientSize = System::Drawing::Size(486, 482);
            this->Controls->Add(this->toolStrip1);
            this->Controls->Add(this->image);
            this->Controls->Add(this->menuStrip1);
            this->MainMenuStrip = this->menuStrip1;
            this->Name = L"Form1";
            this->Text = L"Form1";
            this->Load += gcnew System::EventHandler(this, &Form1::OnLoad);
            (cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->image))->EndInit();
            this->menuStrip1->ResumeLayout(false);
            this->menuStrip1->PerformLayout();
            this->toolStrip1->ResumeLayout(false);
            this->toolStrip1->PerformLayout();
            this->ResumeLayout(false);
            this->PerformLayout();

        }
#pragma endregion
        
        private: System::Void OnLoad(System::Object^  sender, System::EventArgs^  e)
        {
            namespace ZGraphics = ::Graphics;
            
            using namespace Loaders;
            using namespace ZGraphics;
            using namespace Overworld;
            
            std::ifstream f;
            
            Group<8, 16> bgPals;
            
            uint8_t halfPalSelect[0x200];
            
            TileSet<Pixel3bpp, 0x200> bgTiles;
            
            Bitmap ^b = gcnew Bitmap(0x400, 0x400);
            
            // ---------------------------------------------
            
            f.open("..\\Zelda3\\zelda3.smc", std::ios::binary | std::ios::in);
            
            if(!f.bad())
            {
                ei = new ExpandInfo(f);
                
                zg = new ZeldaGame();
                
                if(ei->CheckForExpansion())
                {
                    ModernLoader m(*ei);
                    
                    m.LoadGame(*zg);
                }
                else
                {
                    RomLoader r(*ei);
                    
                    r.LoadGame(*zg);
                }
            }
            
            Area &area = zg->areas[0x70];
            
            OverBgTheme bg_t   = area.bgPalTheme->Redeem();
            OverSprTheme spr_t = area.sprPalTheme[0]->Redeem();
            
            Group<7, 5> bg_prim = bg_t.primary->Redeem();
            Group<7, 3> bg_sec1 = bg_t.secondary1->Redeem();
            Group<7, 3> bg_sec2 = bg_t.secondary2->Redeem();
            Group<7, 1> bg_tert = bg_t.tertiary->Redeem();
            
            Group<7, 1> spr_sec1 = spr_t.secondary1->Redeem();
            Group<7, 1> spr_sec2 = spr_t.secondary2->Redeem();
            
            if(1)
            {
                for(uint32_t i = 0; i < 5; ++i)
                {
                    for(uint32_t j = 0; j < bg_prim.PaletteSize(); ++j)
                    {
                        bgPals[ (i + 2) * 2 ][j + 1] = bg_prim[i][j];
                    }
                }
                
                for(uint32_t i = 0; i < 3; ++i)
                {
                    for(uint32_t j = 0; j < bg_sec1.PaletteSize(); ++j)
                    {
                        bgPals[ ((i + 2) * 2) + 1 ][j + 1] = bg_sec1[i][j];
                    }
                }
                
                for(uint32_t i = 0; i < 3; ++i)
                {
                    for(uint32_t j = 0; j < bg_sec2.PaletteSize(); ++j)
                    {
                        bgPals[ ( (i + 5) * 2 ) + 1 ][j + 1] = bg_sec2[i][j];
                    }
                }
                
                for(uint32_t j = 0; j < bg_tert.PaletteSize(); ++j)
                {
                    bgPals[ (7 * 2) ][j + 1] = bg_tert[0][j];
                }
            }
            
            Map16Buf &map0 = area.areaMap;
            
            if(1)
            {
                // Next decompress the BG graphic data
                
                TileConfig tconfig;
                
                tconfig.bgMain = area.bgTileThemeMain->Redeem();
                tconfig.bgAux  = area.bgTileThemeAux->Redeem();
                
                for(int i = 0, j = 7; i < 8; ++i, --j)
                {
                    // The primary BG tileset (corresponds to $0AA1)
                    Ticket<TileSet3bpp> *ticket = tconfig.bgMain[i];
                    
                    // ---------------------------------------------
                    
                    switch(j)
                    {
                        case 1:
                        case 2:
                        case 3:
                        case 4:
                        {
                            // (corresponds to $0AA2)
                            if(tconfig.bgAux[i - 3] != NULL)
                            {
                                ticket = tconfig.bgAux[i - 3];
                            }
                        }
                        default:
                        {
                            break;
                        }
                    }
                    
                    TileSet3bpp tileSet = ticket->Redeem();
                    
                    for(uint32_t t = 0; t < tileSet.NumTiles(); ++t)
                    {
                        bgTiles(t + (i * 0x40) ) = tileSet(t);
                        
                        switch(j)
                        {
                            case 2:
                            case 3:
                            case 4:
                            case 7:
                            
                                halfPalSelect[t + (i * 0x40)] = 1;
                                
                                break;
                                
                            default:
                            
                                halfPalSelect[t + (i * 0x40)] = 0;
                                
                                break;
                        }
                    }
                }
            }
            
            for(uint32_t t = 0; t < 0x20; ++t)
            {
                TileSet3bpp animated = zg->tileData.bg[0x58].Issue()->Redeem();
                
                // ----------------------------------------------
                
                bgTiles(t + 0x1C0) = animated(t);
                
                halfPalSelect[t + 0x1C0] = 0;
            }
            
            // generate visible state
            for(int i = 0; i < map0.Width(); ++i)
            {
                for(int j = 0; j < map0.Height(); ++j)
                {
                    uint8_t half = 0;
                    
                    uint16_t pal = 0;
                    uint16_t chr = 0;
                    
                    Map16Tile tile = zg->map16To8[ (Map16Val) map0(i, j) ];
                    
                    ZGraphics::Color col;
                    
                    // --------------------------------------
                    
                    chr  = tile[0].GetChr();
                    pal  = tile[0].m_pal;
                    half = halfPalSelect[chr];
                    
                    ZGraphics::ColorTile c0(bgTiles(chr), bgPals[ (pal * 2) + half ], 0);
                    
                    for(int x = 0; x < 8; ++x)
                    {
                        for(int y = 0; y < 8; ++y)
                        {
                            col = c0(y, x, tile[0].m_hFlip, tile[0].m_vFlip);
                            b->SetPixel( (i * 16) + 0 + x, (j * 16) + 0 + y, Drawing::Color::FromArgb( (uint32_t) col ) );
                        }
                    }
                    
                    chr  = tile[1].GetChr();
                    pal  = tile[1].m_pal;
                    half = halfPalSelect[chr];
                    
                    ZGraphics::ColorTile c1(bgTiles(chr), bgPals[ (pal * 2) + half ], 0);
                    
                    for(int x = 0; x < 8; ++x)
                    {
                        for(int y = 0; y < 8; ++y)
                        {
                            col = c1(y, x, tile[1].m_hFlip, tile[1].m_vFlip);
                            b->SetPixel( (i * 16) + 8 + x, (j * 16) + 0 + y, Drawing::Color::FromArgb( (uint32_t) col ) );
                        }
                    }
                    
                    chr  = tile[2].GetChr();
                    pal  = tile[2].m_pal;
                    half = halfPalSelect[chr];
                    
                    ZGraphics::ColorTile c2(bgTiles(chr), bgPals[ (pal * 2) + half ], 0);
                    
                    for(int x = 0; x < 8; ++x)
                    {
                        for(int y = 0; y < 8; ++y)
                        {
                            col = c2(y, x, tile[2].m_hFlip, tile[2].m_vFlip);
                            b->SetPixel( (i * 16) + 0 + x, (j * 16) + 8 + y, Drawing::Color::FromArgb( (uint32_t) col ) );
                        }
                    }
                    
                    chr  = tile[3].GetChr();
                    pal  = tile[3].m_pal;
                    half = halfPalSelect[chr];
                    
                    ZGraphics::ColorTile c3(bgTiles(chr), bgPals[ (pal * 2) + half ], 0);
                    
                    for(int x = 0; x < 8; ++x)
                    {
                        for(int y = 0; y < 8; ++y)
                        {
                            col = c3(y, x, tile[3].m_hFlip, tile[3].m_vFlip);
                            b->SetPixel( (i * 16) + 8 + x, (j * 16) + 8 + y, Drawing::Color::FromArgb( (uint32_t) col ) );
                        }
                    }
                }
            }
            
            /**
            for(int i = 0; i < b->Height; ++i)
            {
                for(int j = 0; j < b->Width; ++j)
                {
                    b->SetPixel(j, i, Drawing::Color::FromArgb( ((i / 2) + (j + 4)) % 0x100,
                                                               (2*i + j) % 0x100,
                                                               (i + j) % 0x100,
                                                               (i + 3*j) % 0x100) );
                }
            }*/
            
            image->Image = b;
            
            frameTimer->Enabled = true;
        }
        
        private: System::Void ShowThemeDialog(System::Object^ sender, System::EventArgs^ e)
        {
            ThemesDialog ^t = gcnew ThemesDialog();
            
            t->Show();
        }
        
        private: System::Void frameTimer_Tick(System::Object^ sender, System::EventArgs^ e)
        {
            
            
        
            image->Invalidate();
        }
        
};
}

