#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;


namespace ZTestGui {

	/// <summary>
	/// Summary for ThemesDialog
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class ThemesDialog : public System::Windows::Forms::Form
	{
	public:
		ThemesDialog(void)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~ThemesDialog()
		{
			if (components)
			{
				delete components;
			}
		}
    private: System::Windows::Forms::ComboBox^  bgMainTileThemeCombo;
    protected: 
    private: System::Windows::Forms::ComboBox^  bgAuxTileThemeCombo;
    private: System::Windows::Forms::ComboBox^  sprMainTileThemeCombo;
    private: System::Windows::Forms::ComboBox^  auxSprTileThemeCombo;

    private: System::Windows::Forms::ComboBox^  bgPalThemeCombo;
    private: System::Windows::Forms::ComboBox^  sprPalThemeCombo;


    private: System::Windows::Forms::Label^  bgMainTileThemeLabel;
    private: System::Windows::Forms::Label^  label1;
    private: System::Windows::Forms::Label^  mainSprTileThemeLabel;
    private: System::Windows::Forms::Label^  auxSprTileThemeLabel;


    private: System::Windows::Forms::Label^  bgPalThemeLabel;

    private: System::Windows::Forms::Label^  sprPalThemeLabel;
    private: System::Windows::Forms::GroupBox^  bgTilesGroup;
    private: System::Windows::Forms::PictureBox^  bgTilesBox;
    private: System::Windows::Forms::GroupBox^  sprTilesGroup;

    private: System::Windows::Forms::PictureBox^  sprTilesBox;







    protected: 

    protected: 

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
            this->bgMainTileThemeCombo = (gcnew System::Windows::Forms::ComboBox());
            this->bgAuxTileThemeCombo = (gcnew System::Windows::Forms::ComboBox());
            this->sprMainTileThemeCombo = (gcnew System::Windows::Forms::ComboBox());
            this->auxSprTileThemeCombo = (gcnew System::Windows::Forms::ComboBox());
            this->bgPalThemeCombo = (gcnew System::Windows::Forms::ComboBox());
            this->sprPalThemeCombo = (gcnew System::Windows::Forms::ComboBox());
            this->bgMainTileThemeLabel = (gcnew System::Windows::Forms::Label());
            this->label1 = (gcnew System::Windows::Forms::Label());
            this->mainSprTileThemeLabel = (gcnew System::Windows::Forms::Label());
            this->auxSprTileThemeLabel = (gcnew System::Windows::Forms::Label());
            this->bgPalThemeLabel = (gcnew System::Windows::Forms::Label());
            this->sprPalThemeLabel = (gcnew System::Windows::Forms::Label());
            this->bgTilesGroup = (gcnew System::Windows::Forms::GroupBox());
            this->bgTilesBox = (gcnew System::Windows::Forms::PictureBox());
            this->sprTilesGroup = (gcnew System::Windows::Forms::GroupBox());
            this->sprTilesBox = (gcnew System::Windows::Forms::PictureBox());
            this->bgTilesGroup->SuspendLayout();
            (cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->bgTilesBox))->BeginInit();
            this->sprTilesGroup->SuspendLayout();
            (cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->sprTilesBox))->BeginInit();
            this->SuspendLayout();
            // 
            // bgMainTileThemeCombo
            // 
            this->bgMainTileThemeCombo->FormattingEnabled = true;
            this->bgMainTileThemeCombo->Location = System::Drawing::Point(12, 30);
            this->bgMainTileThemeCombo->Name = L"bgMainTileThemeCombo";
            this->bgMainTileThemeCombo->Size = System::Drawing::Size(121, 21);
            this->bgMainTileThemeCombo->TabIndex = 0;
            this->bgMainTileThemeCombo->SelectedIndexChanged += gcnew System::EventHandler(this, &ThemesDialog::comboBox1_SelectedIndexChanged);
            // 
            // bgAuxTileThemeCombo
            // 
            this->bgAuxTileThemeCombo->FormattingEnabled = true;
            this->bgAuxTileThemeCombo->Location = System::Drawing::Point(12, 80);
            this->bgAuxTileThemeCombo->Name = L"bgAuxTileThemeCombo";
            this->bgAuxTileThemeCombo->Size = System::Drawing::Size(121, 21);
            this->bgAuxTileThemeCombo->TabIndex = 1;
            // 
            // sprMainTileThemeCombo
            // 
            this->sprMainTileThemeCombo->FormattingEnabled = true;
            this->sprMainTileThemeCombo->Location = System::Drawing::Point(12, 130);
            this->sprMainTileThemeCombo->Name = L"sprMainTileThemeCombo";
            this->sprMainTileThemeCombo->Size = System::Drawing::Size(121, 21);
            this->sprMainTileThemeCombo->TabIndex = 2;
            // 
            // auxSprTileThemeCombo
            // 
            this->auxSprTileThemeCombo->FormattingEnabled = true;
            this->auxSprTileThemeCombo->Location = System::Drawing::Point(12, 180);
            this->auxSprTileThemeCombo->Name = L"auxSprTileThemeCombo";
            this->auxSprTileThemeCombo->Size = System::Drawing::Size(121, 21);
            this->auxSprTileThemeCombo->TabIndex = 3;
            // 
            // bgPalThemeCombo
            // 
            this->bgPalThemeCombo->FormattingEnabled = true;
            this->bgPalThemeCombo->Location = System::Drawing::Point(12, 230);
            this->bgPalThemeCombo->Name = L"bgPalThemeCombo";
            this->bgPalThemeCombo->Size = System::Drawing::Size(121, 21);
            this->bgPalThemeCombo->TabIndex = 4;
            // 
            // sprPalThemeCombo
            // 
            this->sprPalThemeCombo->FormattingEnabled = true;
            this->sprPalThemeCombo->Location = System::Drawing::Point(12, 280);
            this->sprPalThemeCombo->Name = L"sprPalThemeCombo";
            this->sprPalThemeCombo->Size = System::Drawing::Size(121, 21);
            this->sprPalThemeCombo->TabIndex = 5;
            // 
            // bgMainTileThemeLabel
            // 
            this->bgMainTileThemeLabel->AutoSize = true;
            this->bgMainTileThemeLabel->Location = System::Drawing::Point(12, 9);
            this->bgMainTileThemeLabel->Name = L"bgMainTileThemeLabel";
            this->bgMainTileThemeLabel->Size = System::Drawing::Size(104, 13);
            this->bgMainTileThemeLabel->TabIndex = 6;
            this->bgMainTileThemeLabel->Text = L"Main BG Tile Theme";
            this->bgMainTileThemeLabel->Click += gcnew System::EventHandler(this, &ThemesDialog::bgMainTileThemeLabel_Click);
            // 
            // label1
            // 
            this->label1->AutoSize = true;
            this->label1->Location = System::Drawing::Point(12, 59);
            this->label1->Name = L"label1";
            this->label1->Size = System::Drawing::Size(119, 13);
            this->label1->TabIndex = 7;
            this->label1->Text = L"Auxiliary BG Tile Theme";
            this->label1->Click += gcnew System::EventHandler(this, &ThemesDialog::label1_Click);
            // 
            // mainSprTileThemeLabel
            // 
            this->mainSprTileThemeLabel->AutoSize = true;
            this->mainSprTileThemeLabel->Location = System::Drawing::Point(12, 109);
            this->mainSprTileThemeLabel->Name = L"mainSprTileThemeLabel";
            this->mainSprTileThemeLabel->Size = System::Drawing::Size(116, 13);
            this->mainSprTileThemeLabel->TabIndex = 8;
            this->mainSprTileThemeLabel->Text = L"Main Sprite Tile Theme";
            this->mainSprTileThemeLabel->Click += gcnew System::EventHandler(this, &ThemesDialog::label2_Click);
            // 
            // auxSprTileThemeLabel
            // 
            this->auxSprTileThemeLabel->AutoSize = true;
            this->auxSprTileThemeLabel->Location = System::Drawing::Point(12, 159);
            this->auxSprTileThemeLabel->Name = L"auxSprTileThemeLabel";
            this->auxSprTileThemeLabel->Size = System::Drawing::Size(131, 13);
            this->auxSprTileThemeLabel->TabIndex = 9;
            this->auxSprTileThemeLabel->Text = L"Auxiliary Sprite Tile Theme";
            this->auxSprTileThemeLabel->Click += gcnew System::EventHandler(this, &ThemesDialog::label3_Click);
            // 
            // bgPalThemeLabel
            // 
            this->bgPalThemeLabel->AutoSize = true;
            this->bgPalThemeLabel->Location = System::Drawing::Point(9, 209);
            this->bgPalThemeLabel->Name = L"bgPalThemeLabel";
            this->bgPalThemeLabel->Size = System::Drawing::Size(94, 13);
            this->bgPalThemeLabel->TabIndex = 10;
            this->bgPalThemeLabel->Text = L"BG Palette Theme";
            // 
            // sprPalThemeLabel
            // 
            this->sprPalThemeLabel->AutoSize = true;
            this->sprPalThemeLabel->Location = System::Drawing::Point(12, 259);
            this->sprPalThemeLabel->Name = L"sprPalThemeLabel";
            this->sprPalThemeLabel->Size = System::Drawing::Size(94, 13);
            this->sprPalThemeLabel->TabIndex = 11;
            this->sprPalThemeLabel->Text = L"BG Palette Theme";
            // 
            // bgTilesGroup
            // 
            this->bgTilesGroup->Controls->Add(this->bgTilesBox);
            this->bgTilesGroup->Location = System::Drawing::Point(149, 9);
            this->bgTilesGroup->Name = L"bgTilesGroup";
            this->bgTilesGroup->Size = System::Drawing::Size(160, 299);
            this->bgTilesGroup->TabIndex = 12;
            this->bgTilesGroup->TabStop = false;
            this->bgTilesGroup->Text = L"BG Tiles";
            // 
            // bgTilesBox
            // 
            this->bgTilesBox->Location = System::Drawing::Point(8, 17);
            this->bgTilesBox->Name = L"bgTilesBox";
            this->bgTilesBox->Size = System::Drawing::Size(145, 265);
            this->bgTilesBox->TabIndex = 0;
            this->bgTilesBox->TabStop = false;
            // 
            // sprTilesGroup
            // 
            this->sprTilesGroup->Controls->Add(this->sprTilesBox);
            this->sprTilesGroup->Location = System::Drawing::Point(324, 9);
            this->sprTilesGroup->Name = L"sprTilesGroup";
            this->sprTilesGroup->Size = System::Drawing::Size(160, 299);
            this->sprTilesGroup->TabIndex = 13;
            this->sprTilesGroup->TabStop = false;
            this->sprTilesGroup->Text = L"Sprite Tiles";
            // 
            // sprTilesBox
            // 
            this->sprTilesBox->Location = System::Drawing::Point(8, 17);
            this->sprTilesBox->Name = L"sprTilesBox";
            this->sprTilesBox->Size = System::Drawing::Size(145, 265);
            this->sprTilesBox->TabIndex = 0;
            this->sprTilesBox->TabStop = false;
            // 
            // ThemesDialog
            // 
            this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
            this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
            this->ClientSize = System::Drawing::Size(500, 321);
            this->Controls->Add(this->sprTilesGroup);
            this->Controls->Add(this->bgTilesGroup);
            this->Controls->Add(this->sprPalThemeLabel);
            this->Controls->Add(this->bgPalThemeLabel);
            this->Controls->Add(this->auxSprTileThemeLabel);
            this->Controls->Add(this->mainSprTileThemeLabel);
            this->Controls->Add(this->label1);
            this->Controls->Add(this->bgMainTileThemeLabel);
            this->Controls->Add(this->sprPalThemeCombo);
            this->Controls->Add(this->bgPalThemeCombo);
            this->Controls->Add(this->auxSprTileThemeCombo);
            this->Controls->Add(this->sprMainTileThemeCombo);
            this->Controls->Add(this->bgAuxTileThemeCombo);
            this->Controls->Add(this->bgMainTileThemeCombo);
            this->DoubleBuffered = true;
            this->MaximizeBox = false;
            this->MinimizeBox = false;
            this->Name = L"ThemesDialog";
            this->Text = L"ThemesDialog";
            this->Load += gcnew System::EventHandler(this, &ThemesDialog::ThemesDialog_Load);
            this->bgTilesGroup->ResumeLayout(false);
            (cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->bgTilesBox))->EndInit();
            this->sprTilesGroup->ResumeLayout(false);
            (cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->sprTilesBox))->EndInit();
            this->ResumeLayout(false);
            this->PerformLayout();

        }
#pragma endregion
        private: System::Void comboBox1_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e)
        {
            
        }
    private: System::Void ThemesDialog_Load(System::Object^  sender, System::EventArgs^  e) {
             }
private: System::Void bgMainTileThemeLabel_Click(System::Object^  sender, System::EventArgs^  e) {
             }
private: System::Void label1_Click(System::Object^  sender, System::EventArgs^  e) {
             }
private: System::Void label2_Click(System::Object^  sender, System::EventArgs^  e) {
             }
private: System::Void label3_Click(System::Object^  sender, System::EventArgs^  e) {
             }
};
}
