// Not necessarily needed right now, but it's a useful for testing.

    #include <stdint.h>

#ifndef GLOBAL_H

    #define GLOBAL_H
    
    typedef struct
    {
        uint8_t backPal0;    // same as $0AB6      
        uint8_t backGfx0;    // same as $0AA1       
        uint8_t backGfx1;    // same as $0AA2       
        uint8_t spriteGfx0;  // same as $0AA3    
        uint8_t spriteGfx1;  // same as $0AA4 (usually only one of 3 values)
        uint8_t spritePal0;  // same as $0AAC
        uint8_t spritePal1;  // same as $0AAD
        uint8_t spritePal2;  // same as $0AAE 
    } graphicsInfo, *giPtr;
    
    // normal variables
    extern char* bg0_prop_str[];
    extern char* collision_str[];
    extern char* special_effect_str[];
    extern char* special_routine_str[];
    extern char* plane_str[];
    
    extern char* SprStrings[];
    extern char* OverStrings[];
    extern char* ItemStrings[];

    extern char* mainGfxStrings[];
    extern char* auxGfxStrings[];

#endif
