/*
 *	Compresch - compression library
 *  Copyright 2008 Disch
 *  See license.txt for details
 */

    #include <stdint.h>
    #include "compresch_types.h"

#if !defined __COMPRESCH_STDBLOCK_H__

    #define __COMPRESCH_STDBLOCK_H__
    
class Compresch_StdBlock
{
protected:
	static int			WorstCompressSize(int srclen);

	static int			CrunchAndOutput(BlockList& blocks,const uint8_t* src,int srclen,uint8_t* dst);

	static int			OutputRawBlock(const uint8_t* src,uint8_t* dst,int len);
	static int			OutputBlock(Block* blk,uint8_t* dst);

	
	static int			Decompress(const uint8_t* src,int srclen,uint8_t* dst,Block** blocks);
};

#endif