#include <cmath>
#include <boost/python.hpp>

#include "containers_helpers.hpp"

using namespace boost::python;
using namespace Containers;


//Export all relevant items in the Containers namespace
void export_containers()
{
  class_<Slot<uint8_t> >("CharSlot")
    .def("to_i", &Slot<uint8_t>::operator uint8_t)
    .def("IsEmpty", cont_slot_is_empty)
  ;



  class_<Slot<uint16_t> >("Map16Slot")
    .def("get", &Slot<uint16_t>::operator uint16_t)
    .def("IsEmpty", cont_slot16_is_empty)
  ;
}


